;**********************************************************************
;*	                       Szivatty vezrl                           *
;**********************************************************************

list p=p12F508 r=DEC
#include <p12F508.inc>

__CONFIG	_MCLRE_OFF & _CP_OFF & _WDT_OFF & _XT_OSC

;Konstansok

K			equ     .0		;K kapcsol a GPIO0-n
R1			equ	.1		;Rel 1 kimenete GPIO1
R2			equ	.2		;Rel 2 kimenete GPIO2
C_TMR_H			equ	0x4e		;20ms idkonstansnak fels byte-ja
C_TMR_L                 equ     0x20            ;20ms idkonstansnak als byte-ja
MSB                     equ     .7              ;Legmagasabb bit szma
KF                      equ     .6              ;Kapcsol llapotvlts figyels

;Vltozk

TMR_H                   equ     0x07            ;Ksleltess szmllja    
TMR_L                   equ     0x08
FLAGS                   equ     0x09            ;Jelzbitek
REL_CNT                 equ     0x0a            ;5mp belltsa

;Program
                        org     .0              ;Program eleje
                                        
                        clrf    GPIO            ;Port inicializls
                        movlw   B'11111001'     ;GPIO1 s GPIO2 kimenet a tbbi bemenet
                        tris    GPIO            
                        movlw   B'10000000'     ;Felhz ellenllsok bekapcsolsa
                        option
                        movlw   C_TMR_H         ;szmllk s flagek inicializlsa
                        movwf   TMR_H
                        movlw   C_TMR_L
                        movwf   TMR_L                                        
                        clrf    FLAGS
                        clrf    TMR0
main                                            ;Fciklus
                        btfss   GPIO,K          ;Kapcsol be van kapcsolva ugrik
                        goto    k_on
                        bsf     GPIO,R1         ;Rel 1 bekapcsol
                        btfsc   FLAGS,KF        ;llapotvlts ellenzs
                        goto    check           ;Nincs vlts tovbb az idellenrz rutinra
                        bsf     FLAGS,KF        ;Helyes rtk belltsa
                        goto    start_delay     ;5 msodperc innen indul
k_on                                            ;kapcsol bekapcsolt llapotban van
                        bsf     GPIO,R2         ;Rel 2 bekapcsol
                        btfss   FLAGS,KF        ;llapotvlts ellenzs
                        goto    check           ;Nincs vlts tovbb az idellenrz rutinra
                        bcf     FLAGS,KF        ;Helyes rtk belltsa
start_delay                                     ;5mp inicializls
                        movlw   .250            ;250*20ms az idzts
                        movwf   REL_CNT
check                                           ;Idzt
                        movf    REL_CNT,F       ;Ha az idzts lejrt vissza a fciklus elejre
                        btfsc   STATUS,Z
                        goto    main                       
                                                ;A TMR0 legmagasabb bitjnek ellenrzse ezzel max 256 urasts lehet a ciklus eltt s utn
                        btfsc   TMR0,MSB        ;Csak a legmagasabb bit vltsra vagyunk kvncsiak
                        goto    msb_h
                        btfss   FLAGS,MSB       ;Bit alacsony s nem vltozott
                        goto    main            ;Vissza a fciklus elejre
                        bcf     FLAGS,MSB       ;Ha vltozott a jelz tlltsa
                        goto    sub             ;20ms szmllra ugrs 
msb_h
                        btfsc   FLAGS,MSB       ;TMR0 legmagasabb bitje 1 volt s nem vltozott
                        goto    main            ;vissza a fciklus elejre
                        bsf     FLAGS,MSB       ;Ha vltozott a jelz tlltsa 
sub
                        decfsz  TMR_H,F         ;Fels byte cskkents
                        goto    main            ;Ha nem 0 vissza a fciklusra
                        movlw   C_TMR_H         ;Ha nulla letelt az 20 ms
                        movwf   TMR_H           ;Szmllk visszalltsa
                        movlw   C_TMR_L         ;Az als byte kompenzlsa, mivel a ciklus ezt nem tudja nzi
                        addwf   TMR_L,F         ;A felhalmozdsval kompenzlja a fels bjtot
                        btfsc   STATUS,C
                        incf    TMR_H,F
                        decfsz  REL_CNT         ;Letelt 5s ?
                        goto    main            ;Nem
                        btfss   FLAGS,KF        ;Ellenrizzk a kapcsol llst
                        goto    R1_off          ;Megfelel rel kikapcsolsa
                        bcf     GPIO,R2
                        goto    main
R1_off                        
                        bcf     GPIO,R1
                        goto    main
END             